Class | SimpleDelegator
In: | delegate.rb
Parent: | Delegator

A concrete implementation of Delegator, this class provides the means to delegate all supported method calls to the object passed into the constructor and even to change the object being delegated to at a later time with __setobj__ .

### Methods

__getobj__ __setobj__ clone dup new

### Public Class methods

new(obj)

Pass in the obj you would like to delegate method calls to.

[Source]

    # File delegate.rb, line 200
      def initialize(obj)
        super
        @_sd_obj = obj
      end

### Public Instance methods

__getobj__()

Returns the current object method calls are being delegated to.

[Source]

    # File delegate.rb, line 206
      def __getobj__
        @_sd_obj
      end

__setobj__(obj)

Changes the delegate object to obj.

It’s important to note that this does not cause SimpleDelegator’s methods to change. Because of this, you probably only want to change delegation to objects of the same type as the original delegate.

Here’s an example of changing the delegation object.

      names = SimpleDelegator.new(%w{James Edward Gray II})
      puts names[1]    # => Edward
      names.__setobj__(%w{Gavin Sinclair})
      puts names[1]    # => Sinclair

[Source]

    # File delegate.rb, line 224
      def __setobj__(obj)
        raise ArgumentError, "cannot delegate to self" if self.equal?(obj)
        @_sd_obj = obj
      end

clone()

Clone support for the object returned by __getobj__.

[Source]

    # File delegate.rb, line 230
      def clone
        super
        __setobj__(__getobj__.clone)
      end

dup(obj)

Duplication support for the object returned by __getobj__.

[Source]

    # File delegate.rb, line 235
      def dup(obj)
        super
        __setobj__(__getobj__.dup)
      end

[Validate]